org.optaplanner.core.impl.heuristic.selector.move.composite

## Class CartesianProductMoveSelector

- java.lang.Object
- - org.optaplanner.core.impl.heuristic.selector.AbstractSelector
  - - org.optaplanner.core.impl.heuristic.selector.move.AbstractMoveSelector
    - - org.optaplanner.core.impl.heuristic.selector.move.composite.CompositeMoveSelector
      - - org.optaplanner.core.impl.heuristic.selector.move.composite.CartesianProductMoveSelector

- All Implemented Interfaces:
    Iterable<Move>, EventListener, IterableSelector<Move>, MoveSelector, Selector, PhaseLifecycleListener, SolverLifecycleListener

      public class CartesianProductMoveSelector
      extends CompositeMoveSelector

  A `CompositeMoveSelector` that Cartesian products 2 or more `MoveSelector`s.

  For example: a Cartesian product of {A, B, C} and {X, Y} will result in {AX, AY, BX, BY, CX, CY}.

  Warning: there is no duplicated `Move` check, so union of {A, B} and {B} will result in {AB, BB}.

  See Also:
    `CompositeMoveSelector`

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `class` | `CartesianProductMoveSelector.OriginalCartesianProductMoveIterator`
    `class` | `CartesianProductMoveSelector.RandomCartesianProductMoveIterator`

  - ### Field Summary

    - ### Fields inherited from class org.optaplanner.core.impl.heuristic.selector.move.composite.CompositeMoveSelector

      `childMoveSelectorList, randomSelection`

    - ### Fields inherited from class org.optaplanner.core.impl.heuristic.selector.AbstractSelector

      `logger, phaseLifecycleSupport, workingRandom`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `CartesianProductMoveSelector(List<MoveSelector> childMoveSelectorList, boolean ignoreEmptyChildIterators, boolean randomSelection)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `long` | `getSize()` A random JIT `Selector` with `Selector.isNeverEnding()` true should return a size as if it would be able to return each distinct element only once, because the size can be used in `SelectionProbabilityWeightFactory`.
    `boolean` | `isNeverEnding()` Is true if `Selector.isCountable()` is false or if this selector is in random order (for most cases).
    `Iterator<Move>` | `iterator()`
    `String` | `toString()`

    - ### Methods inherited from class org.optaplanner.core.impl.heuristic.selector.move.composite.CompositeMoveSelector

      `getChildMoveSelectorList, isCountable, supportsPhaseAndSolverCaching`

    - ### Methods inherited from class org.optaplanner.core.impl.heuristic.selector.AbstractSelector

      `getCacheType, phaseEnded, phaseStarted, solvingEnded, solvingStarted, stepEnded, stepStarted`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.optaplanner.core.impl.heuristic.selector.Selector

      `getCacheType`

    - ### Methods inherited from interface org.optaplanner.core.impl.phase.event.PhaseLifecycleListener

      `phaseEnded, phaseStarted, stepEnded, stepStarted`

    - ### Methods inherited from interface org.optaplanner.core.impl.solver.event.SolverLifecycleListener

      `solvingEnded, solvingStarted`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach, spliterator`

- - ### Constructor Detail

    - #### CartesianProductMoveSelector

          public CartesianProductMoveSelector(List<MoveSelector> childMoveSelectorList,
                                              boolean ignoreEmptyChildIterators,
                                              boolean randomSelection)

  - ### Method Detail

    - #### isNeverEnding

          public boolean isNeverEnding()

      Description copied from interface: `Selector`
      Is true if `Selector.isCountable()` is false or if this selector is in random order (for most cases). Is never true when this selector is in shuffled order (which is less scalable but more exact).
      Returns:
        true if the `Iterator.hasNext()` of the `Iterator` created by `Iterable.iterator()` never returns false (except when it's empty).

    - #### getSize

          public long getSize()

      Description copied from interface: `IterableSelector`
      A random JIT `Selector` with `Selector.isNeverEnding()` true should return a size as if it would be able to return each distinct element only once, because the size can be used in `SelectionProbabilityWeightFactory`.
      Returns:
        the approximate number of elements generated by this `Selector`, always `>= 0`

    - #### iterator

          public Iterator<Move> iterator()

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `CompositeMoveSelector`

Copyright © 2006–2020 JBoss by Red Hat. All rights reserved.